/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 

#ifndef BARRA_H_
#define BARRA_H_

#include <SDL.h>
#include "defines.h"
#include "elementos.h"
#include "fuente.h"
#include "intercom.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
 
 
class Elemento;
class Frame;
class Fuente;
class Juego;
class Intercom;
 
class Barra {
	
private:
	Elemento *barra;
	Elemento *vida[7];
	Elemento *barra_poder, *cangrejo, *luces, *poderes, *compuerta;
	Elemento *txtPuntos, *txtNPoderes, *txtNivel, *txtFase, *txtPersonaje;
	int auxPuntos, auxNPoderes, auxNivel, auxPersonaje;
	int ciclosParpadeoCangrejo;
	Fuente *f;
	int pantalla_w;
	int pantalla_h;
	int sizeFontCartel, sizeFontPuntos, sizeFontPoderes;
		
public:
	Elemento *persPaco, *persBizcone, *persMadre, *persSuperman;
	Barra(Juego *j);
	int xEnPantalla (int x);
	int yEnPantalla (int y);
	void dibujarBarra(SDL_Surface *screen, Juego *juego, Intercom *i);
	void unLoad();
};

#endif /* BARRA_H_ */
