/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */

#ifndef DEFINES_H_
#define DEFINES_H_

#define DATA_DIR "/usr/share/tirititran/data"

#define NOPCIONES 8
#define NOPCIONES_OPCIONES 8
#define TIEMPOENTRADAJUGADOR 110
#define ESPERADISPAROS 4
#define RAFAGADISPAROS 8
#define MAXMAP 2600
#define MAXMAPNIEBLA 1170
#define MAXMAPNUBES 1170
#define MAXTILES 130
#define TIEMPOABRIRCAJASDIALOGO 8
#define TIEMPOBLOQUEODISPAROSENEMIGOS 40
#define TIEMPOFIESTAFINAL3 178
#define NUMERODISPAROS2 70
#define TIEMPOPARARELEMENTOSPANTALLA 60
#define NUMEROCONTINUES 1

#define MAXBALAS 40
#define MAXENE_GEN1 15 // maximo de enemigos generales nivel 1
#define MAXENE_GEN2 4 // maximo de enemigos generales nivel 2
#define MAXENE_GEN3 2 // maximo de enemigos generales nivel 3
#define MAXDISP_PEQ 40 // maximo de disparos pequeños
#define MAXDISP_GR 40 // maximo de disparos grandes
#define MAXDISP_ROT 30 // maximo de disparos rotatorios
#define MAXDISP_POMPA 5 // maximo de disparos pompa
#define MAXAGREGADORES 4
#define MAXENE_MARINOS 4
#define MAXENE_AUTOMARINO 4
#define MAXENE_CONSTRUCCIONES 4
#define MAXENE_MINA 8
#define MAXENE_CPOLICIA 4
#define MAXENE_TANQUE 2
#define MAXENE_TAXI 4
#define MAXENE_BARRERAS 4
#define MAXENE_EXPBARRERAS 10
#define MAXENE_CSIMPLE 6
#define MAXENE_CARROZAS 4
#define MAXTIEMPO_PODER 400
#define MAXCONVERSACIONES 2
#define MAXEXP_MED 6
#define MAXEXP_GR 3
#define MAX_CHISPAS 10
#define MAX_NIEBLA 6
#define MAX_NUBES 20
#define MAXPALMERAS 6
#define MAXFAROLA 6
#define MAXENE_YATE 2
#define MAXENE_CONCHA 4
#define MAX_BALON 25
#define MAX_ALQUITRAN 30

// numero de movimientos y de disparos de los enemigos
#define NUM_MOVIMIENTOS 50
#define NUM_DISPAROS 50

// como moverse los elementos

#define COORDENADASNORMALES 0
#define COORDENADASPOLARES 1
#define PORPOSICION 2

// tipos de rotaciones
#define ROTACION_PENDULAR 0
#define ROTACION_CIRCULAR 1

// movimientos del jugador

#define MOVIMIENTO_IZQ 0 
#define MOVIMIENTO_DER 1 
#define MOVIMIENTO_SIN 2
#define MOVIMIENTO_ESTABLECERSE_DESDE_IZQ 3
#define MOVIMIENTO_ESTABLECERSE_DESDE_DER 4

// alineaciones

#define ALIGN_LEFT 0 
#define ALIGN_CENTER 1 
#define ALIGN_RIGHT 2 
#define VALIGN_TOP 0 
#define VALIGN_CENTER 1 
#define VALIGN_BOTTOM 2 

// direcciones

#define DIR_RIGHT 0
#define DIR_LEFT 1

// Estados del juego

#define JUEGO_PAUSA 0
#define JUEGO_PORTADA 1
#define JUEGO_ESCENA 2
#define JUEGO_OVER 3
#define JUEGO_OPCIONES 4
#define JUEGO_CONTINUE 5
#define JUEGO_RECORD 6
#define JUEGO_SALIRPARTIDA 7
#define JUEGO_INTERCOM 8
#define JUEGO_MISIONFRACASADA 9
#define JUEGO_SEL_PODER 10
#define JUEGO_COMOJUGAR 11

// personajes del intercomunicador

#define PERS_TIRITITRAN 0
#define PERS_PACOALBA 1
#define PERS_BIZCONE 2
#define PERS_CADIZTV 3
#define PERS_MADRE 4
#define PERS_SUPERMAN 5

// definiciones de todos los enemigos, disparos y explosiones
#define GAVIOTA1 0
#define EXP_GAVIOTA1 1
#define EXP_GAVIOTA2 2
#define GAVIOTA2 3
#define NAVEPEQUENYA 4
#define EXP_NAVEPEQUENYA 5
#define GAVIBOTS 6
#define NAVEMEDIANA 7
#define EXP_NAVEMED 8
#define NAVEGRANDE 9
#define EXP_NAVEGRANDE 10
#define NAVEZEPELIN 11
#define DISPARO_PEQ 12
#define DISPARO_GR 13
#define EXP_DISPARO_GR 14
#define AGREGADOR 15
#define CANGREBOT 16
#define EXP_CANGREBOT 17
#define LANCHA 18
#define EXP_LANCHA 19
#define CASETA 20
#define EXP_CASETA 21
#define MINA 22
#define DISPARO_ROT 23
#define DISPARO_POMPAGR 24
#define DISPARO_POMPAPEQ 25
#define EXP_POMPAGR 26
#define EXP_POMPAPEQ 27
#define COCHE_POLICIA 28
#define TANQUE 29
#define TAXI 30
#define COCHESIMPLE 31
#define BARRERA_IZQ 32
#define BARRERA_DER 33
#define VALLA_IZQ 34
#define VALLA_DER 35
#define EXP_COCHE 36
#define CARROZA 37
#define EXP_MEDIANA 38
#define EXP_MEDIANA1 39
#define EXP_TORRE 40
#define DISPARO_GR_AZUL 41
#define EXP_DISPARO_GR_AZUL 42
#define HELICOPTERO 43
#define EXP_GRANDE 44
#define EXP_BARRERA 45
#define EXP_TANQUE 46
#define EXP_COCHE_CORTA 47
#define CHISPA 48
#define PALMERA 49
#define FAROLA 50
#define PULPO 51
#define EXP_PULPO 52
#define NAVERASCASIO 53
#define YATE 54
#define AVISPA 55
#define CONCHA 56
#define BALON 57
#define EXP_YATE 58

// Tipos de coches simples

#define MERCEDES_CREMA 0
#define MERCEDES_GRIS 1
#define MERCEDES_ROJO 2
#define AUTOBUS 3
#define KADETT_AZUL 4
#define KADETT_ROJO 5
#define KADETT_VERDE 6
#define PICASSO_AZUL 7
#define PICASSO_GRIS 8
#define PICASSO_VIOLETA 9
#define SEICENTO_GRIS 10
#define SMART_AMARILLO 11
#define SMART_AZUL 12
#define SMART_VERDE 13

// Tipos de carrozas

#define CASTILLO 0
#define DEMONIO 1
#define MAR 2
#define PIRATA 3

// definiciones de tipos de disparos
#define DISP_GRADO0 0
#define DISP_GRADO1 1
#define DISP_GRADO2 2
#define DISP_GRADO3 3
#define DISP_GRADO4 4
#define DISP_GRADO5 5
#define DISP_GRADO6 6
#define DISP_GRADO7 7
#define DISP_GRADO8 8
#define DISP_GRADO9 9
#define DISP_GRADO10 10
#define DISP_GRADO11 11
#define DISP_GRADO12 12
#define DISP_GRADO13 13
#define DISP_GRADO14 14
#define DISP_GRADO15 15
#define DISP_GRADOALJUGADOR 16
#define DISP_ALJUGADOR 17
#define DISP_2ABAJO 18
#define DISP_5ABAJO 19
#define DISP_6LATERALES 20
#define DISP_4OBLICUO 21
#define DISP_DIRIGIDO 22
#define DISP_RAFAGA_GR 23
#define DISP_3ABAJO 24
#define DISP_8CIRCULAR 25
#define DISP_RAFAGA 26
#define DISP_3ABAJO_CERRADO 27
#define DISP_RAFAGA_MED 28
#define DISP_4CRUZ 29
#define DISP_8 30

// tipos de movimientos

#define MOV_NORMAL 0
#define MOV_KAMIKAZE 1
#define MOV_PARADO 2
#define MOV_MIRANDOJUGADOR 3
#define MOV_FRENAR 4
#define MOV_IMPULSAR 5
#define MOV_PARADO_ENFINAL 6

// tipos de agregadores

#define AG_PODER 0
#define AG_VIDA 1
#define AG_DISPARO 2
#define AG_NONE 3

// sonidos

#define SND_DISPARO 0
#define SND_EXPLOSION 1
#define SND_CLICK 2
#define SND_BEEP 3
#define SND_BEEP1 4
#define SND_BOMBA 5
#define SND_EXPAGUA 6
#define SND_EXPCASETA 7
#define SND_AGREGADOR 8
#define SND_POP 9
#define SND_FRASE_CLONACION0 10
#define SND_FRASE_INVISIBILIDAD 11
#define SND_FRASE_ESCUDO 12
#define SND_SIRENAS 13
#define SND_EXP_PAJAROS 14
#define SND_CASTANUELAS 15
#define SND_INTERCOM 16
#define SND_MUERTE0 17
#define SND_COMP_CERRAR 18
#define SND_COMP_ABRIR 19
#define SND_MUERTE1 20
#define SND_EXP_GRANDE 21
#define SND_EXP_JEFES 22
#define SND_SILBIDO 23
#define SND_AG_VIDA 24
#define SND_AG_PODER 25
#define SND_AG_DISPARO_LASER 26
#define SND_ESE_CADI 27
#define SND_ENERGIATOPE0 28
#define SND_MUERTE2 29
#define SND_MUERTE3 30
#define SND_MUERTE4 31
#define SND_MUERTE5 32
#define SND_MUERTE6 33
#define SND_MUERTE7 34
#define SND_MUERTE8 35
#define SND_MUERTE9 36
#define SND_MUERTE10 37
#define SND_MUERTE11 38
#define SND_ENERGIATOPE1 39
#define SND_ENERGIATOPE2 40
#define SND_AG_DISPARO_TRIPLE 41
#define SND_FRASE_CLONACION1 42
#define SND_ACTIVAR_BOMBA0 43
#define SND_ACTIVAR_BOMBA1 44
#define SND_ACTIVAR_ESCUDO 45
#define SND_ACTIVAR_AMARILLO 46
#define SND_ACTIVAR_CLONACION 47
#define SND_DESACTIVAR_PODER0 48
#define SND_DESACTIVAR_PODER1 49
#define SND_DESACTIVAR_PODER2 50


// botones joystick

#define JOY_DISPARO 0
#define JOY_SEL_PODER 1
#define JOY_USAR_PODER 2
#define JOY_INTERCOM 3

// musica

#define MUS_OPCIONES 0
#define MUS_FASE1 1
#define MUS_FASE2 2
#define MUS_FASE3 3
#define MUS_FINAL1 4
#define MUS_FINAL2 5
#define MUS_FINAL3 6
#define MUS_CABARGATA 7
#define MUS_GADITANA 8
#define MUS_CANO 9

// velocidad de movimientos

#define VEL_MAPA 2
#define VEL_MUYLENTO 2
#define VEL_LENTO 4
#define VEL_NORMAL 6
#define VEL_RAPIDO 8
#define VEL_MUYRAPIDO 10

// puntos

#define PUNTOS_GENERAL1 10
#define PUNTOS_GENERAL2 100
#define PUNTOS_GENERAL3 250
#define PUNTOS_MARINOS 150
#define PUNTOS_CASETA 120
#define PUNTOS_TANQUE 220
#define PUNTOS_COCHESIMPLE 50
#define PUNTOS_COCHEPOLICIA 200
#define PUNTOS_TAXI 150
#define PUNTOS_BARRERAS 10
#define PUNTOS_JEFE1 1500
#define PUNTOS_JEFE2 1000
#define PUNTOS_JEFE3 1800
#define PUNTOS_TORREBALNEARIO 500
#define PUNTOS_CARROZA 500
#define PUNTOS_CONCHA 200

// impactos para morir

#define IMPACTOS_NAVEMED 10
#define IMPACTOS_NAVEGR 22
#define IMPACTOS_CANGREBOT 10
#define IMPACTOS_PULPO 10
#define IMPACTOS_CASETA 8
#define IMPACTOS_MINA 8
#define IMPACTOS_COCHEPOLICIA 6
#define IMPACTOS_TANQUE 16
#define IMPACTOS_TAXI 6
#define IMPACTOS_BARRERA 5
#define IMPACTOS_COCHESIMPLE 2
#define IMPACTOS_JEFE1 220
#define IMPACTOS_JEFE2 220
#define IMPACTOS_JEFE3 130
#define IMPACTOS_TORREBALNEARIO 50
#define IMPACTOS_CARROZA 30
#define IMPACTOS_YATE 10
#define IMPACTOS_CONCHA 10

// dioses

#define DIOS_BACO 0
#define DIOS_HERCULES 1
#define DIOS_NEPTUNO 2

#endif /* DEFINES_H_ */
