/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
/*****************************
**
** CLASE INTERCOM
**
******************************/

#include "intercom.h"

Intercom::Intercom(Configuracion * conf) {
	config = conf;
	intercomAbierto = 0;
	personajeIntercom = PERS_PACOALBA;
	
	tConversacion auxConversacion;
	
	// cargando conversaciones de fase
	
	auxConversacion.id = 1;
	auxConversacion.fase = 1;
	auxConversacion.personaje = PERS_PACOALBA;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 2;
	auxConversacion.fase = 1;
	auxConversacion.personaje = PERS_PACOALBA;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 1;
	auxConversacion.fase = 2;
	auxConversacion.personaje = PERS_PACOALBA;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 2;
	auxConversacion.fase = 2;
	auxConversacion.personaje = PERS_PACOALBA;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 1;
	auxConversacion.fase = 3;
	auxConversacion.personaje = PERS_PACOALBA;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 2;
	auxConversacion.fase = 3;
	auxConversacion.personaje = PERS_BIZCONE;
	
	conversaciones.push_back(auxConversacion);
	
	// cargando conversaciones aleatorias
	
	auxConversacion.id = 0;
	auxConversacion.fase = 0;
	auxConversacion.personaje = PERS_SUPERMAN;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 1;
	auxConversacion.fase = 0;
	auxConversacion.personaje = PERS_SUPERMAN;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 2;
	auxConversacion.fase = 0;
	auxConversacion.personaje = PERS_MADRE;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 3;
	auxConversacion.fase = 0;
	auxConversacion.personaje = PERS_MADRE;
	
	conversaciones.push_back(auxConversacion);
	
	auxConversacion.id = 4;
	auxConversacion.fase = 0;
	auxConversacion.personaje = PERS_MADRE;
	
	conversaciones.push_back(auxConversacion);
	
	numeroAleatorias = 5;
	
}

char* Intercom::BufferFromRar(char *fileRar, char *file)
{
  char *data_ptr;
  unsigned long data_size;

  if(urarlib_get(&data_ptr, &data_size, file, fileRar, "password")) 
  {
	return data_ptr;
    //if(data_ptr != NULL) free(data_ptr);
  } else 
  { 
    printf("Error al descomprimir!: %s - %s\n", fileRar, file); 
  }
  return data_ptr;
}

void Intercom::abrirIntercom(int f, int id, Audio *son) {
	int i;
	intercomAbierto = 1; 
	if (id == -1) {
		idConversacionActual = obtenerAleatoria();		
	} else {
		idConversacionActual = id; 
	}
	idFaseActual = f;
	// localizamos el personaje
	for (i=0; i<conversaciones.size(); i++) {
		if ( (conversaciones[i].fase == idFaseActual) && (conversaciones[i].id == idConversacionActual) ) {
			personajeIntercom = conversaciones[i].personaje;
		}
	}
	
	idNConversacion = rand()%3;
	
	// caso especial de la segunda conversacion de la fase 2
	if ( (idFaseActual == 2) && (idConversacionActual == 2) ) {
		switch (idNConversacion) {
			case 0:
				personajeIntercom = PERS_PACOALBA;
			break;
			case 1:
				personajeIntercom = PERS_BIZCONE;
			break;
			case 2:
				personajeIntercom = PERS_MADRE;
			break;
		}
	}
	
	son->empezarIntercom();
	
}

void Intercom::abrirIntercomComoJugar(Audio *son) {
	int i;
	intercomAbierto = 1; 
	idConversacionActual = 0;
	idFaseActual = 0;
	personajeIntercom = PERS_PACOALBA;
	
	son->empezarIntercom();
	
}

void Intercom::cerrarIntercom(Audio *son) { 
	intercomAbierto = 0; 
	son->terminarIntercom();
}


int Intercom::obtenerAleatoria() { 
	int i;
	
	bool ponera0 = 1;
	
	for (i=0; i<numeroAleatorias; i++) {
		if (arAleatorias[i]==0) {
			ponera0 = 0;
			break;			
		}
	}
	
	if (ponera0) {
		for (i=0; i<numeroAleatorias; i++) {
			arAleatorias[i] = 0;
		}
	}
	
	int conversacion = rand()%numeroAleatorias;
	
	while (arAleatorias[conversacion] == 1) {
		
		conversacion = rand()%numeroAleatorias;
		
	}
	return conversacion;
	
}

void Intercom::cargarAnimacion () {

	char cadena[127];
	char xml[127];

	anim = new SDL_Animation(screen, 640, 480);
	sprintf (cadena, "%s/verabd.tttf", DATA_DIR);
	anim->inVariable("fuente", cadena);
	anim->inVariable("conf_ruta", config->getDirectorio());

	sprintf (cadena, "%s/conversaciones.tc", DATA_DIR);
	
	if (idFaseActual == 0) { // es una conversacion aleatoria
		sprintf (xml, "aleatoria%d.txml", idConversacionActual);
	} else { // conversacion de fase
		sprintf (xml, "fase%d_%d_%d.txml", idFaseActual, idConversacionActual, idNConversacion); 
	}

	anim->loadBuffer(BufferFromRar(cadena, xml), "intercom.tim");

}

void Intercom::cargarAnimacionComoJugar () {

	char cadena[127];
	char xml[127];

	anim = new SDL_Animation(screen, 640, 480);
	sprintf (cadena, "%s/verabd.tttf", DATA_DIR);
	anim->inVariable("fuente", cadena);
	anim->inVariable("conf_ruta", config->getDirectorio());

	sprintf (cadena, "%s/conversaciones.tc", DATA_DIR);
	
	sprintf (xml, "comojugar.txml");
	
	anim->loadBuffer(BufferFromRar(cadena, xml), "intercom.tim");

}

int Intercom::dibujarAnimacion () {

	int r = anim->DrawAnimation();

	return r;
	
}

char* Intercom::getNombrePersonajeIntercom(int p) {
	 switch(p) {
		 case PERS_TIRITITRAN:
			 return "Tirititran";
		 break;
		 case PERS_PACOALBA:
			 return "Paco Alba";
		 break;
		 case PERS_BIZCONE:
			 return "Biscone";
		 break;
		 case PERS_CADIZTV:
			 return "TV Cádiz";
		 break;
		 case PERS_MADRE:
			 return "Mamá";
		 break;
		 case PERS_SUPERMAN:
			 return "Supermán";
		 break;
	 }
	 return "";
}

char* Intercom::getNombrePersonajeIntercom() {
	return getNombrePersonajeIntercom(personajeIntercom);
}
