/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
#ifndef MAPA_H_
#define MAPA_H_

#include <SDL.h>
#include "defines.h"
#include "elementos.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

class Elemento;
class Frame;
class Juego;

class Mapa {

private:
	int indice, indice_in;
	Elemento *suelo[MAXTILES];

	char *mapa, *nt;

	int velocidad;
	Elemento *fondofinal;
	int numTilesActual;
	Elemento *palmeras[MAXPALMERAS];
	Elemento *farola[MAXFAROLA];
public:
	Mapa();
	char* BufferFromRar(char *fileRar, char *file);
	int elementoLibre (int ele);
	void dibujarElementos (SDL_Surface *screen, Juego *j);
	void dibujarTilesMapa (SDL_Surface *screen);
	void dibujarMapa (SDL_Surface *screen);
	void dibujarFinal (SDL_Surface *screen, Juego *j);
	void CargarNivel(int l, SDL_Surface *screen);
	void iniciar(int i);
	void stop() { velocidad = 0; }
	void play() { velocidad = 2; }
	void setVelocidad(int v) { velocidad = v; };
	int getVelocidad() { return velocidad; };
	void addVelocidad() { velocidad++; };
	void removeVelocidad() { velocidad--; };
	void unLoad();
};


#endif /* MAPA_H_ */
