/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 /*****************************
**
** CLASE SONIDO
**
******************************/

#include "sonido.h"

Audio::Audio(Configuracion *config) {
	salir = 0;
	conf = config;
}

SDL_RWops* Audio::RWFromRar(char *fileRar, char *file)
{
  char *data_ptr;
  unsigned long data_size;
  SDL_RWops *rwops;

  if(urarlib_get(&data_ptr, &data_size, file, fileRar, "password")) 
  {
	rwops = SDL_RWFromMem(data_ptr, data_size);
    //if(data_ptr != NULL) free(data_ptr);
  } else 
  { 
    printf("Error al descomprimir!: %s, %s\n", fileRar, file); 
  }
  return rwops;
}


void Audio::initSonido() {
	salir = 0;	
	//if (Mix_OpenAudio (MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, 2, 4096) < 0) {
	if (Mix_OpenAudio (44100, AUDIO_S16, 2, 4096) < 0) {
		printf ("No se puede iniciar SDL_MIXER: %s\n", SDL_GetError());
		salir = 1;
	}
	Mix_AllocateChannels(16);
}


void Audio::cargarSonido () {
	char fileRAR[128];
	
	// carga musica y sonidos
	sprintf (fileRAR, "%s/sonidos.tso", DATA_DIR);
	musica1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "fase1.tsog"), 1);
	if ( musica1 == NULL ) {
		printf ("Musica no cargada: %s\n", Mix_GetError());
	}
	
	musica2 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "fase2.tsog"), 1);
	if ( musica2 == NULL ) {
		printf ("Musica no cargada: %s\n", Mix_GetError());
	}
	
	musica3 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "fase3.tsog"), 1);
	if ( musica3 == NULL ) {
		printf ("Musica no cargada: %s\n", Mix_GetError());
	}
	
	final1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "final1.tsog"), 1);
	if ( final1 == NULL ) {
		printf ("Musica no cargada: %s\n", Mix_GetError());
	}
	
	final2 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "final2.tsog"), 1);
	if ( final2 == NULL ) {
		printf ("Musica no cargada: %s\n", Mix_GetError());
	}
	
	final3 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "final3.tsog"), 1);
	if ( final3 == NULL ) {
		printf ("Musica no cargada: %s\n", Mix_GetError());
	}
	
	opciones = Mix_LoadWAV_RW (RWFromRar(fileRAR, "opciones.tsog"), 1);
	if ( opciones == NULL ) {
		printf ("Música de opciones no cargada: %s\n", Mix_GetError());
	}
	
	cabargata = Mix_LoadWAV_RW (RWFromRar(fileRAR, "cabargata.tsog"), 1);
	
	cano = Mix_LoadWAV_RW (RWFromRar(fileRAR, "cano.tsog"), 1);
	
	gaditana = Mix_LoadWAV_RW (RWFromRar(fileRAR, "gaditana.tsog"), 1);
	
	comp_cerrar = Mix_LoadWAV_RW (RWFromRar(fileRAR, "compuertas_cerrar.tsog"), 1);
	
	comp_abrir = Mix_LoadWAV_RW (RWFromRar(fileRAR, "compuertas_abrir.tsog"), 1);
	
	ag_vida = Mix_LoadWAV_RW (RWFromRar(fileRAR, "ag_vidagratis.tsog"), 1);
	ag_poder = Mix_LoadWAV_RW (RWFromRar(fileRAR, "ag_poder.tsog"), 1);
	ag_disparo_laser = Mix_LoadWAV_RW (RWFromRar(fileRAR, "ag_disparo_laser.tsog"), 1);
	ag_disparo_triple = Mix_LoadWAV_RW (RWFromRar(fileRAR, "ag_disparo_triple.tsog"), 1);
	
	castanuelas = Mix_LoadWAV_RW (RWFromRar(fileRAR, "castanuelas.tsog"), 1);
		
	intercom = Mix_LoadWAV_RW (RWFromRar(fileRAR, "intercom.tsog"), 1);
	
	exp_grande = Mix_LoadWAV_RW (RWFromRar(fileRAR, "exp_grande.tsog"), 1);
	
	exp_jefes = Mix_LoadWAV_RW (RWFromRar(fileRAR, "exp_jefes.tsog"), 1);
	
	muerte0 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_0.tsog"), 1);
	muerte1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_1.tsog"), 1);
	muerte2 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_2.tsog"), 1);
	muerte3 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_3.tsog"), 1);
	muerte4 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_4.tsog"), 1);
	muerte5 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_5.tsog"), 1);
	muerte6 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_6.tsog"), 1);
	muerte7 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_7.tsog"), 1);
	muerte8 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_8.tsog"), 1);
	muerte9 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_9.tsog"), 1);
	muerte10 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_10.tsog"), 1);
	muerte11 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "muerte_11.tsog"), 1);
	
	ese_cadi = Mix_LoadWAV_RW (RWFromRar(fileRAR, "esecadi.tsog"), 1);
	
	energia_tope0 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "energiatope0.tsog"), 1);
	energia_tope1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "energiatope1.tsog"), 1);
	energia_tope2 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "energiatope2.tsog"), 1);
	
	silbido = Mix_LoadWAV_RW (RWFromRar(fileRAR, "silbidos.tsog"), 1);
	
	bomba = Mix_LoadWAV_RW (RWFromRar(fileRAR, "bombapoderes.tsog"), 1);
	
	exp_pajaros = Mix_LoadWAV_RW (RWFromRar(fileRAR, "explosion_pajaros.tsog"), 1);
	
	sirenas = Mix_LoadWAV_RW (RWFromRar(fileRAR, "sirenas.tsog"), 1);
	
	explosion = Mix_LoadWAV_RW (RWFromRar(fileRAR, "explosion.tsog"), 1);
	
	disparo = Mix_LoadWAV_RW (RWFromRar(fileRAR, "disparo.tsog"), 1);
	
	click = Mix_LoadWAV_RW (RWFromRar(fileRAR, "click.tsog"), 1);
	
	beep = Mix_LoadWAV_RW (RWFromRar(fileRAR, "beep.tsog"), 1);
	
	beep1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "beep1.tsog"), 1);
	
	explosionagua = Mix_LoadWAV_RW (RWFromRar(fileRAR, "explosion_agua.tsog"), 1);
	
	explosioncaseta = Mix_LoadWAV_RW (RWFromRar(fileRAR, "explosion_caseta.tsog"), 1);

	agregador = Mix_LoadWAV_RW (RWFromRar(fileRAR, "agregador.tsog"), 1);
	
	pop = Mix_LoadWAV_RW (RWFromRar(fileRAR, "pop.tsog"), 1);
	
	frase_clonacion0 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "clonacion0.tsog"), 1);
	frase_clonacion1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "clonacion1.tsog"), 1);
	
	frase_invisibilidad = Mix_LoadWAV_RW (RWFromRar(fileRAR, "invisibilidad.tsog"), 1);
	
	frase_escudo = Mix_LoadWAV_RW (RWFromRar(fileRAR, "superescudo.tsog"), 1);
	
	act_escudo = Mix_LoadWAV_RW (RWFromRar(fileRAR, "act_escudo.tsog"), 1);
	act_bomba0 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "act_bomba0.tsog"), 1);
	act_bomba1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "act_bomba1.tsog"), 1);
	act_amarillo = Mix_LoadWAV_RW (RWFromRar(fileRAR, "act_amarillo.tsog"), 1);
	act_clonacion = Mix_LoadWAV_RW (RWFromRar(fileRAR, "act_clonacion.tsog"), 1);
	
	desact_poder0 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "desact_poder0.tsog"), 1);
	desact_poder1 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "desact_poder1.tsog"), 1);
	desact_poder2 = Mix_LoadWAV_RW (RWFromRar(fileRAR, "desact_poder2.tsog"), 1);
	
	establecerVolumenes();
}

void Audio::establecerVolumenes () {
	Mix_VolumeChunk (musica1, 40*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (musica2, 50*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (musica3, 50*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (final1, 50*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (final2, 40*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (final3, 40*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (opciones, 60*conf->getOpcion("vol_musica"));
	
	Mix_VolumeChunk (cabargata, 50*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (cano, 30*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (gaditana, 40*conf->getOpcion("vol_musica"));
	
	Mix_VolumeChunk (comp_cerrar, 40*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (comp_abrir, 40*conf->getOpcion("vol_sonido"));
	
	Mix_VolumeChunk (bomba, 30*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (exp_pajaros, 45*conf->getOpcion("vol_sonido"));
	
	Mix_VolumeChunk (castanuelas, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (intercom, 10*conf->getOpcion("vol_sonido"));
	
	Mix_VolumeChunk (muerte0, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte1, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte2, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte3, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte4, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte5, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte6, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte7, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte8, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte9, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte10, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (muerte11, 25*conf->getOpcion("vol_sonido"));
	
	Mix_VolumeChunk (ese_cadi, 45*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (energia_tope0, 55*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (energia_tope1, 55*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (energia_tope2, 55*conf->getOpcion("vol_sonido"));
	
	Mix_VolumeChunk (silbido, 35*conf->getOpcion("vol_sonido"));
	
	Mix_VolumeChunk (ag_vida, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (ag_poder, 25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (ag_disparo_laser,25*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (ag_disparo_triple, 25*conf->getOpcion("vol_sonido"));
	
	Mix_VolumeChunk (sirenas, 60*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (explosion, 12*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (exp_jefes, 70*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (exp_grande, 70*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (disparo, 10*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (click, 10*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (beep, 10*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (beep1, 10*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (explosionagua, 50*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (explosioncaseta, 15*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (agregador, 15*conf->getOpcion("vol_sonido"));
	Mix_VolumeChunk (pop, 8*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (frase_clonacion0, 25*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (frase_clonacion1, 25*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (frase_invisibilidad, 25*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (frase_escudo, 25*conf->getOpcion("vol_sonido"));	
	
	Mix_VolumeChunk (act_escudo, 30*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (act_bomba0, 25*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (act_bomba1, 25*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (act_amarillo, 30*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (act_clonacion, 25*conf->getOpcion("vol_sonido"));	
	
	Mix_VolumeChunk (desact_poder0, 25*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (desact_poder1, 25*conf->getOpcion("vol_sonido"));	
	Mix_VolumeChunk (desact_poder2, 25*conf->getOpcion("vol_sonido"));	
}

void Audio::empezarMusica (int mus) {
	switch (mus) {
		case MUS_OPCIONES:
			Mix_PlayChannel (15, opciones, -1);
			//Mix_FadeInChannel (0, opciones, -1, 2000);
		break;
		case MUS_FASE1:
			Mix_FadeInChannel (15, musica1, -1, 2000);			
		break;
		case MUS_FASE2:
			Mix_FadeInChannel (15, musica2, -1, 2000);			
		break;
		case MUS_FASE3:
			Mix_FadeInChannel (15, musica3, -1, 2000);
		break;
		case MUS_FINAL1:
			Mix_FadeInChannel (15, final1, -1, 2000);
		break;
		case MUS_FINAL2:
			Mix_FadeInChannel (15, final2, -1, 2000);
		break;
		case MUS_FINAL3:
			Mix_FadeInChannel (15, final3, -1, 2000);
		break;
	}

}

void Audio::terminarMusica () {
	Mix_FadeOutChannel (15, 1300);
}


void Audio::empezarMusicaSecundaria (int mus) {
	switch (mus) {
		case MUS_CABARGATA:
			Mix_VolumeChunk (musica3, 25*conf->getOpcion("vol_musica"));
			Mix_FadeInChannel (9, cabargata, -1, 2000);
		break;
		case MUS_GADITANA:
			Mix_VolumeChunk (final3, 25*conf->getOpcion("vol_musica"));
			Mix_FadeInChannel (9, gaditana, -1, 2000);			
		break;
		case MUS_CANO:
			Mix_FadeOutChannel (15, 6000);			
			Mix_FadeInChannel (9, cano, -1, 6000);
			//Mix_VolumeChunk (musica2, 0);
			//Mix_PlayChannel (9, cano, -1);	
		break;
	}

}

void Audio::terminarMusicaSecundaria () {
	Mix_FadeOutChannel (9, 2000);
	Mix_VolumeChunk (final3, 40*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (musica3, 50*conf->getOpcion("vol_musica"));
	Mix_VolumeChunk (musica2, 50*conf->getOpcion("vol_musica"));
}

void Audio::empezarIntercom () {
	Mix_PlayChannel (7, intercom, -1);
}

void Audio::terminarIntercom () {
	Mix_FadeOutChannel (7, 0);
}
// canales
// 15 para la musica
// 1 para los disparos
// 2 para las explosion
// 3 para las frases de poderes
// 4 para la sirenas
// 5 para la bomba
// 6 para la castanuelas
// 8 para frases de agregadores (disparo, vida, poder)


void Audio::playSonido (int son) {
	switch (son) {
		case SND_DISPARO:
			Mix_PlayChannel (1, disparo, 0);
		break;
		case SND_EXPLOSION:
			Mix_PlayChannel (2, explosion, 0);
		break;
		case SND_CLICK:
			Mix_PlayChannel (-1, click, 0);
		break;
		case SND_BEEP:
			Mix_PlayChannel (-1, beep, 0);
		break;
		case SND_BEEP1:
			Mix_PlayChannel (-1, beep1, 0);
		break;
		case SND_BOMBA:
			Mix_PlayChannel (5, bomba, 0);
		break;
		case SND_EXPAGUA:
			Mix_PlayChannel (-1, explosionagua, 0);
		break;
		case SND_EXPCASETA:
			Mix_PlayChannel (-1, explosioncaseta, 0);
		break;
		case SND_AGREGADOR:
			Mix_PlayChannel (-1, agregador, 0);
		break;
		case SND_POP:
			Mix_PlayChannel (-1, pop, 0);
		break;
		case SND_FRASE_CLONACION0:
			Mix_PlayChannel (3, frase_clonacion0, 0);
		break;
		case SND_FRASE_CLONACION1:
			Mix_PlayChannel (3, frase_clonacion1, 0);
		break;
		case SND_FRASE_INVISIBILIDAD:
			Mix_PlayChannel (3, frase_invisibilidad, 0);
		break;
		case SND_FRASE_ESCUDO:
			Mix_PlayChannel (3, frase_escudo, 0);
		break;
		case SND_SIRENAS:
			Mix_PlayChannel (4, sirenas, 0);
		break;
		case SND_EXP_PAJAROS:
			Mix_PlayChannel (-1, exp_pajaros, 0);
		break;
		case SND_CASTANUELAS:
			Mix_PlayChannel (6, castanuelas, 0);
		break;
		case SND_MUERTE0:
			Mix_PlayChannel (8, muerte0, 0);
		break;
		case SND_MUERTE1:
			Mix_PlayChannel (8, muerte1, 0);
		break;
		case SND_MUERTE2:
			Mix_PlayChannel (8, muerte2, 0);
		break;
		case SND_MUERTE3:
			Mix_PlayChannel (8, muerte3, 0);
		break;
		case SND_MUERTE4:
			Mix_PlayChannel (8, muerte4, 0);
		break;
		case SND_MUERTE5:
			Mix_PlayChannel (8, muerte5, 0);
		break;
		case SND_MUERTE6:
			Mix_PlayChannel (8, muerte6, 0);
		break;
		case SND_MUERTE7:
			Mix_PlayChannel (8, muerte7, 0);
		break;
		case SND_MUERTE8:
			Mix_PlayChannel (8, muerte8, 0);
		break;
		case SND_MUERTE9:
			Mix_PlayChannel (8, muerte9, 0);
		break;
		case SND_MUERTE10:
			Mix_PlayChannel (8, muerte10, 0);
		break;
		case SND_MUERTE11:
			Mix_PlayChannel (8, muerte11, 0);
		break;
		case SND_AG_DISPARO_LASER:
			Mix_PlayChannel (8, ag_disparo_laser, 0);
		break;
		case SND_AG_DISPARO_TRIPLE:
			Mix_PlayChannel (8, ag_disparo_triple, 0);
		break;
		case SND_AG_VIDA:
			Mix_PlayChannel (8, ag_vida, 0);
		break;
		case SND_AG_PODER:
			Mix_PlayChannel (8, ag_poder, 0);
		break;
		case SND_COMP_ABRIR:
			Mix_PlayChannel (-1, comp_abrir, 0);
		break;
		case SND_COMP_CERRAR:
			Mix_PlayChannel (-1, comp_cerrar, 0);
		break;
		case SND_EXP_GRANDE:
			Mix_PlayChannel (-1, exp_grande, 0);
		break;
		case SND_EXP_JEFES:
			Mix_PlayChannel (-1, exp_jefes, 0);
		break;
		case SND_SILBIDO:
			Mix_PlayChannel (-1, silbido, 0);
		break;
		case SND_ESE_CADI:
			Mix_PlayChannel (3, ese_cadi, 0);
		break;
		case SND_ENERGIATOPE0:
			Mix_PlayChannel (3, energia_tope0, 0);
		break;
		case SND_ENERGIATOPE1:
			Mix_PlayChannel (3, energia_tope1, 0);
		break;
		case SND_ENERGIATOPE2:
			Mix_PlayChannel (3, energia_tope2, 0);
		break;
		case SND_ACTIVAR_BOMBA0:
			Mix_PlayChannel (3, act_bomba0, 0);
		break;
		case SND_ACTIVAR_BOMBA1:
			Mix_PlayChannel (3, act_bomba1, 0);
		break;
		case SND_ACTIVAR_ESCUDO:
			Mix_PlayChannel (3, act_escudo, 0);
		break;
		case SND_ACTIVAR_CLONACION:
			Mix_PlayChannel (3, act_clonacion, 0);
		break;
		case SND_ACTIVAR_AMARILLO:
			Mix_PlayChannel (3, act_amarillo, 0);
		break;
		case SND_DESACTIVAR_PODER0:
			Mix_PlayChannel (3, desact_poder0, 0);
		break;
		case SND_DESACTIVAR_PODER1:
			Mix_PlayChannel (3, desact_poder1, 0);
		break;
		case SND_DESACTIVAR_PODER2:
			Mix_PlayChannel (3, desact_poder2, 0);
		break;
	}
}

void Audio::unLoadSonido () {
	//Mix_HaltMusic();
	Mix_FreeChunk(musica1);
	Mix_FreeChunk(musica2);
	Mix_FreeChunk(musica3);
	Mix_FreeChunk(final1);
	Mix_FreeChunk(final2);
	Mix_FreeChunk(final3);
	Mix_FreeChunk(cano);
	Mix_FreeChunk(opciones);
	Mix_FreeChunk(comp_cerrar);
	Mix_FreeChunk(comp_abrir);
	Mix_FreeChunk(ag_vida);
	Mix_FreeChunk(ag_poder);
	Mix_FreeChunk(ag_disparo_laser);
	Mix_FreeChunk(ag_disparo_triple);
	Mix_FreeChunk(cabargata);
	Mix_FreeChunk(gaditana);
	Mix_FreeChunk(bomba);
	Mix_FreeChunk(exp_pajaros);
	Mix_FreeChunk(castanuelas);
	Mix_FreeChunk(intercom);
	Mix_FreeChunk(muerte0);
	Mix_FreeChunk(muerte1);
	Mix_FreeChunk(muerte2);
	Mix_FreeChunk(muerte3);
	Mix_FreeChunk(muerte4);
	Mix_FreeChunk(muerte5);
	Mix_FreeChunk(muerte6);
	Mix_FreeChunk(muerte7);
	Mix_FreeChunk(muerte8);
	Mix_FreeChunk(muerte9);
	Mix_FreeChunk(muerte10);
	Mix_FreeChunk(muerte11);
	Mix_FreeChunk(ese_cadi);
	Mix_FreeChunk(energia_tope0);
	Mix_FreeChunk(energia_tope1);
	Mix_FreeChunk(energia_tope2);
	Mix_FreeChunk(silbido);
	Mix_FreeChunk(explosion);
	Mix_FreeChunk(exp_grande);
	Mix_FreeChunk(exp_jefes);
	Mix_FreeChunk(disparo);
	Mix_FreeChunk(click);
	Mix_FreeChunk(beep);
	Mix_FreeChunk(beep1);
	Mix_FreeChunk(explosionagua);
	Mix_FreeChunk(explosioncaseta);
	Mix_FreeChunk(pop);
	Mix_FreeChunk(agregador);
	Mix_FreeChunk(frase_clonacion0);
	Mix_FreeChunk(frase_clonacion1);
	Mix_FreeChunk(frase_escudo);
	Mix_FreeChunk(frase_invisibilidad);
	Mix_FreeChunk(sirenas);
	Mix_FreeChunk(act_bomba0);
	Mix_FreeChunk(act_bomba1);
	Mix_FreeChunk(act_escudo);
	Mix_FreeChunk(act_amarillo);
	Mix_FreeChunk(act_clonacion);
	Mix_FreeChunk(desact_poder0);
	Mix_FreeChunk(desact_poder1);
	Mix_FreeChunk(desact_poder2);
	Mix_CloseAudio();
}
