/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 #include "tiempo.h"
 
 /*****************************
**
** CLASE MAPA
**
******************************/

 Tiempo::Tiempo() {
	//niebla_indice = MAXMAPNIEBLA - 169;
	//niebla_indice_in = 0;
	nubes_indice = MAXMAPNUBES - 169;
	nubes_indice_in = 0;
	 
	tiles_niebla = 4;

	activarNieve = 0;
	ciclosNieve = -1;
	activarCarnaval = 0;
	ciclosCarnaval = -1;
	 
	int i;
	 
	for ( i=0; i<MAX_NIEBLA; i++ ) {
		niebla[i]= new Elemento();
	}
	for ( i=0; i<MAX_NUBES; i++ ) {
		nubes[i]= new Elemento();
	}
	
	for ( i=0; i<MAXNIEVE; i++ ) {
		nieve[i]= new Elemento();
	}
	
	for ( i=0; i<MAXLLUVIA; i++ ) {
		lluvia[i]= new Elemento();
	}
	
	for ( i=0; i<MAXCARNAVAL; i++ ) {
		carnaval[i]= new Elemento();
	}
	
	velocidad_niebla = 0;
	velocidad_nubes = 0;
	

}
 

void Tiempo::dibujarNiebla (SDL_Surface *screen) {
	if (velocidad_niebla>0) {
		int i;
		
		for (i=0; i<MAX_NIEBLA; i++) {
			niebla[i]->addY(velocidad_niebla);
			if (!niebla[i]->fueraLimitesDePantalla()) {
				niebla[i]->dibujar(screen);
			}
			// si la última nube sale, se para la niebla
			if (niebla[MAX_NIEBLA-1]->getY()>480) {
				velocidad_niebla = 0;
			}
		}
		
		/*
		int i,j,x,y,t;
		int dim = 40;
		int tiles_ancho = 13;
		int tiles_alto = 13;
	
		niebla_indice_in+=velocidad_niebla;
		if (niebla_indice_in >= dim) {
			niebla_indice_in = 0;
			niebla_indice -= tiles_ancho;
		}
		
		if (niebla_indice <= 0) {
			niebla_indice = MAXMAPNIEBLA-169;
			niebla_indice_in = 0;
			velocidad_niebla = 0;
		}
		int cont=0;
		for (i=0; i<tiles_alto; i++) {
			for (j=0; j<tiles_ancho; j++) {
				t = mapa_niebla[niebla_indice+(i*tiles_ancho+j)];
				cont++;
				x = j * dim;
				y = (i-1) * dim + niebla_indice_in;
				niebla[t]->selFrame(0);
				niebla[t]->setX(x);
				niebla[t]->setY(y);
				if (t<7) {
					niebla[t]->dibujar(screen);
				}
			}		
		}*/
	}
}


void Tiempo::dibujarNubes (SDL_Surface *screen) {
	if (velocidad_nubes>0) {
		int i;
		
		for (i=0; i<MAX_NUBES; i++) {
			nubes[i]->addY(velocidad_nubes);
			if (!nubes[i]->fueraLimitesDePantalla()) {
				nubes[i]->dibujar(screen);
			}
			// si la última nube sale, se para la niebla
			if (nubes[MAX_NUBES-1]->getY()>480) {
				velocidad_nubes = 0;
			}
		}
		/*
		int i,j,x,y,t;
		int dim = 40;
		int tiles_ancho = 13;
		int tiles_alto = 13;
	
		nubes_indice_in+=velocidad_nubes;
		if (nubes_indice_in >= dim) {
			nubes_indice_in = 0;
			nubes_indice -= tiles_ancho;
		}
		
		if (nubes_indice <= 0) {
			nubes_indice = MAXMAPNUBES-169;
			nubes_indice_in = 0;
			velocidad_nubes = 0;
		}
		int cont=0;
		for (i=0; i<tiles_alto; i++) {
			for (j=0; j<tiles_ancho; j++) {
				t = mapa_nubes[nubes_indice+(i*tiles_ancho+j)];
				//printf("%d\n", t);
				cont++;
				x = j * dim;
				y = (i-1) * dim + nubes_indice_in;
				if ( (t<17) && (t>=0)) {
					nubes[t]->selFrame(0);
					nubes[t]->setX(x);
					nubes[t]->setY(y);
					nubes[t]->dibujar(screen);
				}
			}		
		}*/
	}
}


void Tiempo::dibujarNieve (SDL_Surface *screen) {
	if (activarNieve==1) {
		int i, numNieveActiva;
		for (i=0; i<MAXNIEVE; i++) {
			if (nieve[i]->getActivo()==1) {
				nieve[i]->mover();
				nieve[i]->dibujar(screen);
				if  (nieve[i]->fueraLimitesDePantalla()) {
					if ( activarNieve == 1 ) {
						nieve[i]->setX((int)(rand()%650));
						nieve[i]->setY ( (int)(rand()%10));
					} else {
						nieve[i]->setActivo(0);
					}
				}
			}
		}
		if (ciclosNieve>=0) {
			// activar mas nieve
			switch(ciclosNieve) {
				case 0:
					numNieveActiva = MAXNIEVE/10;
				break;
				case 20:
					numNieveActiva = (MAXNIEVE/10)*2;
				break;
				case 40:
					numNieveActiva = (MAXNIEVE/10)*3;
				break;
				case 60:
					numNieveActiva = (MAXNIEVE/10)*4;
				break;
				case 80:
					numNieveActiva = (MAXNIEVE/10)*5;
				break;
				case 100:
					numNieveActiva = (MAXNIEVE/10)*6;
				break;
				case 120:
					numNieveActiva = (MAXNIEVE/10)*7;
				break;
				case 140:
					numNieveActiva = (MAXNIEVE/10)*7;
				break;
				case 160:
					numNieveActiva = (MAXNIEVE/10)*8;
				break;
				case 180:
					numNieveActiva = (MAXNIEVE/10)*9;
				break;
				case 200:
					numNieveActiva = MAXNIEVE;
				break;
			}
			
			for (int i=0; i<numNieveActiva; i++) {
				nieve[i]->setActivo(1);
			}
			
			ciclosNieve++;
		}
	}
}

void Tiempo::playNieve () { 
	activarNieve = 1;
	ciclosNieve = 0;
}

void Tiempo::stopNieve () { 
	activarNieve = 0; 	
}

void Tiempo::dibujarLluvia (SDL_Surface *screen) {
	if (activarLluvia==1) {
		int i;
		for (i=0; i<MAXLLUVIA; i++) {
			if (lluvia[i]->getActivo()==1) {
				lluvia[i]->mover();
				lluvia[i]->dibujar(screen);
				if  (lluvia[i]->fueraLimitesDePantalla()) {
					if ( activarLluvia == 1 ) {
						lluvia[i]->setX((int)(rand()%650));
						lluvia[i]->setY ( (int)(rand()%600));
					} else {
						lluvia[i]->setActivo(0);
					}
				}
			}
		}
	}
}

void Tiempo::playLluvia () { 
	activarLluvia = 1; 	
	for (int i=0; i<MAXLLUVIA; i++) {
		lluvia[i]->setActivo(1);
	}
}

void Tiempo::stopLluvia () { 
	activarLluvia = 0; 	
}

void Tiempo::dibujarCarnaval (SDL_Surface *screen) {
	if (activarCarnaval==1) {
		int i, numCarnavalActiva;
		for (i=0; i<MAXCARNAVAL; i++) {
			if (carnaval[i]->getActivo()==1) {
				carnaval[i]->mover();
				carnaval[i]->dibujar(screen);
				if  (carnaval[i]->fueraLimitesDePantalla()) {
					if ( activarCarnaval == 1 ) {
						carnaval[i]->setX((int)(rand()%480));
						carnaval[i]->setY ( (int)(rand()%10));
					} else {
						carnaval[i]->setActivo(0);
					}
				}
			}
		}
		if (ciclosCarnaval>=0) {
			// activar mas nieve
			switch(ciclosCarnaval) {
				case 0:
					numCarnavalActiva = MAXCARNAVAL/10;
				break;
				case 20:
					numCarnavalActiva = (MAXCARNAVAL/10)*2;
				break;
				case 40:
					numCarnavalActiva = (MAXCARNAVAL/10)*3;
				break;
				case 60:
					numCarnavalActiva = (MAXCARNAVAL/10)*4;
				break;
				case 80:
					numCarnavalActiva = (MAXCARNAVAL/10)*5;
				break;
				case 100:
					numCarnavalActiva = (MAXCARNAVAL/10)*6;
				break;
				case 120:
					numCarnavalActiva = (MAXCARNAVAL/10)*7;
				break;
				case 140:
					numCarnavalActiva = (MAXCARNAVAL/10)*7;
				break;
				case 160:
					numCarnavalActiva = (MAXCARNAVAL/10)*8;
				break;
				case 180:
					numCarnavalActiva = (MAXCARNAVAL/10)*9;
				break;
				case 200:
					numCarnavalActiva = MAXCARNAVAL;
				break;
			}
			
			for (int i=0; i<numCarnavalActiva; i++) {
				carnaval[i]->setActivo(1);
			}
			
			ciclosCarnaval++;
		}
	}
}

void Tiempo::stopCarnaval () { 
	activarCarnaval = 0; 	
}

void Tiempo::playCarnaval () { 
	activarCarnaval = 1; 	
	for (int i=0; i<MAXCARNAVAL; i++) {
		carnaval[i]->setActivo(1);
	}
}


char* Tiempo::BufferFromRar(char *fileRar, char *file)
{
  char *data_ptr;
  unsigned long data_size;

  if(urarlib_get(&data_ptr, &data_size, file, fileRar, "password")) 
  {
	return data_ptr;
    //if(data_ptr != NULL) free(data_ptr);
  } else 
  { 
    printf("Error al descomprimir!\n"); 
  }
  return data_ptr;
}

void Tiempo::CargarNiebla () {
	char tmpfile[50];
	char rarMapa[128];
	//int i, ntiles;
	Frame frNiebla0, frNiebla1, frNiebla2, frNiebla3;
	
	// cargar mapa
	
	sprintf (rarMapa, "%s/nubes.tma", DATA_DIR);
	
	//mapa_niebla = BufferFromRar(rarMapa, "mapa.map");
	
	//nt = BufferFromRar(rarMapa, "ntiles.dsc");
	//ntiles = atoi (nt);
	//tiles_niebla = ntiles;
	
	sprintf (tmpfile, "niebla0.timp");
	frNiebla0.loadFromRAR(rarMapa, tmpfile);
	
	sprintf (tmpfile, "niebla1.timp");
	frNiebla1.loadFromRAR(rarMapa, tmpfile);
	
	sprintf (tmpfile, "niebla2.timp");
	frNiebla2.loadFromRAR(rarMapa, tmpfile);
	
	sprintf (tmpfile, "niebla3.timp");
	frNiebla3.loadFromRAR(rarMapa, tmpfile);
	
	niebla[0]->addFrame(frNiebla0);
	
	niebla[1]->addFrame(frNiebla1);
	
	niebla[2]->addFrame(frNiebla3);
	
	niebla[3]->addFrame(frNiebla2);
	
	niebla[4]->addFrame(frNiebla0);
	
	niebla[5]->addFrame(frNiebla1);

}

void Tiempo::playNiebla () {
	velocidad_niebla = 3;
	niebla[0]->setX(-80);
	niebla[0]->setY(-400);
	niebla[1]->setX(170);
	niebla[1]->setY(-620);
	niebla[2]->setX(340);
	niebla[2]->setY(-940);
	niebla[3]->setX(0);
	niebla[3]->setY(-1120);
	niebla[4]->setX(300);
	niebla[4]->setY(-1400);
	niebla[5]->setX(-20);
	niebla[5]->setY(-1490);
}

void Tiempo::playNubes () {
	velocidad_nubes = 3;
	nubes[0]->setX(-50);
	nubes[0]->setY(-400);
	nubes[1]->setX(240);
	nubes[1]->setY(-400);
	
	nubes[2]->setX(-60);
	nubes[2]->setY(-700);
	nubes[3]->setX(220);
	nubes[3]->setY(-720);
	
	nubes[4]->setX(-80);
	nubes[4]->setY(-1020);
	nubes[5]->setX(240);
	nubes[5]->setY(-1000);
	
	nubes[6]->setX(-60);
	nubes[6]->setY(-1300);
	nubes[7]->setX(220);
	nubes[7]->setY(-1310);
	
	nubes[8]->setX(-90);
	nubes[8]->setY(-1600);
	nubes[9]->setX(210);
	nubes[9]->setY(-1590);
	
	nubes[10]->setX(-50);
	nubes[10]->setY(-1900);
	nubes[11]->setX(240);
	nubes[11]->setY(-1910);
	
	nubes[12]->setX(-60);
	nubes[12]->setY(-2090);
	nubes[13]->setX(230);
	nubes[13]->setY(-2080);
	
	nubes[14]->setX(-70);
	nubes[14]->setY(-2270);
	nubes[15]->setX(220);
	nubes[15]->setY(-2240);
	
	nubes[16]->setX(-60);
	nubes[16]->setY(-2540);
	nubes[17]->setX(220);
	nubes[17]->setY(-2550);
	
	nubes[18]->setX(-50);
	nubes[18]->setY(-2820);
	nubes[19]->setX(210);
	nubes[19]->setY(-2850);

}

void Tiempo::CargarNubes () {
	//Frame frNubes[18];
	char tmpfile[50];
	char rarMapa[128];
	//int i, ntiles;

	// cargar mapa
	
	sprintf (rarMapa, "%s/nubes.tma", DATA_DIR);
	
	Frame frNube;
	
	sprintf (tmpfile, "nube0.timp");
	frNube.loadFromRAR(rarMapa, tmpfile);

	int i;
	
	for (i=0; i<MAX_NUBES; i++) {	
		nubes[i]->addFrame(frNube);
	}	

	/*
	mapa_nubes = BufferFromRar(rarMapa, "mapa.map");
	
	nt = BufferFromRar(rarMapa, "ntiles.dsc");
	ntiles = atoi (nt);
	tiles_nubes = ntiles;
	
	for (i=0; i<=ntiles; i++) {
		sprintf (tmpfile, "tiles\\tile%d.timp", i);
		frNubes[i].loadFromRAR(rarMapa, tmpfile);
		nubes[i]->addFrame(frNubes[i]);
	}*/
}


void Tiempo::CargarNieve () {
	Frame frNieve0, frNieve1;
	char fileRAR[128];
	int dirY;
	
	sprintf (fileRAR, "%s/tiempo.tim", DATA_DIR);
	frNieve0.loadFromRAR(fileRAR, "nieve0.timp");
	
	frNieve1.loadFromRAR(fileRAR, "nieve1.timp");
	
	for (int i=0; i<MAXNIEVE; i++) {
		if (i%6==0) {
			nieve[i]->addFrame(frNieve0);
		} else {
			nieve[i]->addFrame(frNieve1);
		}
    	nieve[i]->setX((int)(rand()%520));
    	nieve[i]->setY ( (int)(rand()%10));
		nieve[i]->setDX( ((int)((rand()%2)?((int)(rand()%4)):(-(int)(rand()%4)))) );
		dirY = (int)(rand()%5);
		while (dirY <=2) {
			dirY = (int)(rand()%5);
		}
		nieve[i]->setDY (dirY);
	}
}


void Tiempo::CargarCarnaval () {
	Frame frCanarval0, frCanarval1, frCanarval2, frCanarval3, frCanarval4, frCanarval5;
	char fileRAR[128];
	int dirY;
	
	sprintf (fileRAR, "%s/tiempo.tim", DATA_DIR);
	frCanarval0.loadFromRAR(fileRAR, "papelillo0.timp");
	frCanarval1.loadFromRAR(fileRAR, "papelillo1.timp");
	frCanarval2.loadFromRAR(fileRAR, "papelillo2.timp");
	frCanarval3.loadFromRAR(fileRAR, "papelillo3.timp");
	frCanarval4.loadFromRAR(fileRAR, "papelillo4.timp");
	frCanarval5.loadFromRAR(fileRAR, "papelillo5.timp");
	
	for (int i=0; i<MAXCARNAVAL; i++) {
		if (i%6==0) {
			carnaval[i]->addFrame(frCanarval0);
		} else if (i%5==0) {
			carnaval[i]->addFrame(frCanarval1);
		} else if (i%7==0) {
			carnaval[i]->addFrame(frCanarval2);
		} else if (i%4==0) {
			carnaval[i]->addFrame(frCanarval3);
		} else if (i%8==0) {
			carnaval[i]->addFrame(frCanarval4);
		} else {
			carnaval[i]->addFrame(frCanarval5);
		}
    	carnaval[i]->setX((int)(rand()%520));
    	carnaval[i]->setY ( (int)(rand()%10));
		carnaval[i]->setDX( ((int)((rand()%2)?((int)(rand()%4)):(-(int)(rand()%4)))) );
		dirY = (int)(rand()%5);
		while (dirY <=2) {
			dirY = (int)(rand()%5);
		}
		carnaval[i]->setDY (dirY);
	}
}


void Tiempo::CargarLluvia () {
	Frame frLluvia;
	char fileRAR[128];
	int dirY;
	
	sprintf (fileRAR, "%s/tiempo.tim", DATA_DIR);
	frLluvia.loadFromRAR(fileRAR, "lluvia.timp");
	
	for (int i=0; i<MAXLLUVIA; i++) {
		lluvia[i]->addFrame(frLluvia);
    	lluvia[i]->setX((int)(rand()%520));
    	lluvia[i]->setY ( (int)(rand()%480));
		lluvia[i]->setDX( (-(int)(rand()%4))  );
		dirY = (int)(rand()%7);
		while (dirY <4) {
			dirY = (int)(rand()%7);
		}
		lluvia[i]->setDY (dirY);
	}
}


void Tiempo::iniciar () {
	//niebla_indice = MAXMAPNIEBLA - 169;
	//niebla_indice_in = 0;
	nubes_indice = MAXMAPNIEBLA - 169;
	nubes_indice_in = 0;
	
	velocidad_niebla = 0;
	velocidad_nubes = 0;
	
	stopNiebla();
	
	stopCarnaval();
	stopLluvia();
	stopNieve();
	
}

void Tiempo::unLoad () {
	int i;
	for ( i=0; i<MAXNIEVE; i++ ) {
		nieve[i]->unLoad();
	}
	
	for ( i=0; i<MAXLLUVIA; i++ ) {
		lluvia[i]->unLoad();
	}
	
	for ( i=0; i<MAXCARNAVAL; i++ ) {
		carnaval[i]->unLoad();
	}
	
	for ( i=0; i<tiles_niebla; i++ ) {
		niebla[i]->unLoad();
	}
	tiles_niebla = 0;
	
	for ( i=0; i<MAX_NUBES; i++ ) {
		nubes[i]->unLoad();
	}
	tiles_nubes = 0;

}
